package com.fluentadflowreactnativesdk
import com.facebook.react.bridge.ReactApplicationContext
import android.content.Context
import com.facebook.react.bridge.ReactContextBaseJavaModule
import com.facebook.react.bridge.ReactMethod
import com.facebook.react.bridge.Promise
import android.util.Log
import com.fluent.adflowsdk.adflow.AdFlowListener
import com.fluent.adflowsdk.adflow.FluentAdflowWidget

class FluentAdFlowWidgetModule(reactContext: ReactApplicationContext) :
  ReactContextBaseJavaModule(reactContext) {
  var context: Context? = null

  init {
    this.context = reactContext.getApplicationContext() // This is where you get the context
  }

  override fun getName(): String {
    return NAME
  }

  @ReactMethod
  fun initSdk(apiKey: String, referer: String? = null) {
    if(this.context != null) {
      if(referer != null) {
        FluentAdflowWidget.init(this.context, apiKey, (referer))
      } else {
        FluentAdflowWidget.init(this.context, apiKey)
      }
    }
  }

  companion object {
    const val NAME = "FluentAdFlowAdsSdk"
  }
}
