package com.fluentadflowreactnativesdk

import android.content.Context
import android.graphics.Color
import android.util.Log
import android.widget.FrameLayout
import android.app.Activity
import android.view.View
import android.os.Bundle
import android.view.ViewGroup
import android.widget.Button
import android.widget.Toast
import com.facebook.react.bridge.ReadableMap
import com.fluent.adflowsdk.adflow.FluentAdflowWidget
import com.fluent.adflowsdk.adflow.AdFlowListener
import com.facebook.react.modules.core.DeviceEventManagerModule
import com.facebook.react.uimanager.ThemedReactContext


class FluentAdFlowWidgetView(context: ThemedReactContext) : FrameLayout(context) {
  var reactContext:ThemedReactContext? = null
  init {
    this.reactContext = context
  }

  public fun launchWebView(params: ReadableMap) {
    val paramsMap = convertReadableMapToHashMap(params);
    val parentView = this;
    val sampleAdComponent: View = FluentAdflowWidget()
      //optional listerner
      .setAdFlowListener(object : AdFlowListener {
        override fun onViewDismiss() {
          Log.d("tag", "close event")
          if (parentView.reactContext != null) {
            (parentView.reactContext as ThemedReactContext)
              .getJSModule(DeviceEventManagerModule.RCTDeviceEventEmitter::class.java)
              .emit("onAdFlowContainerClosed", null)
          }
        }
        override fun onViewLoaded() {
          Log.d("tag", "load event")
          if (parentView.reactContext != null) {
            (parentView.reactContext as ThemedReactContext)
              .getJSModule(DeviceEventManagerModule.RCTDeviceEventEmitter::class.java)
              .emit("onAdFlowContainerShow", null)
          }
        }
        override fun onContentHeightChanged(height: String ) {
          Log.d("tag", "height changed event")
          if (parentView.reactContext != null) {
            (parentView.reactContext as ThemedReactContext)
              .getJSModule(DeviceEventManagerModule.RCTDeviceEventEmitter::class.java)
              .emit("onAdFlowContainerHeightChanged", height)
          }
        }
      })
      .show(parentView.reactContext, paramsMap)
    this.addView(sampleAdComponent)
  }
  fun convertReadableMapToHashMap(readableMap: ReadableMap): HashMap<String, String> {
    val hashMap = HashMap<String, String>()
    val iterator = readableMap.keySetIterator()

    while (iterator.hasNextKey()) {
      val key = iterator.nextKey()
      val value = readableMap.getString(key)
      if (value != null) {
        hashMap[key] = value
      }
    }

    return hashMap
  }

}
